classdef COMTRADE<handle
    
    properties
        %%     
        path %,      - 
        filename %    -  
        station_name='PowerStation';
        rec_dev_id='DoomsdayDevice'
        sys_freq=50;
        sample_freq;
        timemult=1;
    end
    
    methods (Static)
        %%  
        function CreateComtrade(Info, times, data)
            %%   .dat 
            %DatFileName = strcat(sscanf(Info.filename,'%1s',length(Info.filename)-4), '.dat');
            FileName=COMTRADE.RemoveExtension(Info.filename);%   
            Path=COMTRADE.AddSlash(Info.path);
            
            PathAndDatName=[Path  FileName '.dat'];
            %{
            %  
            %An, ch_id, ph, ccbm, uu, a, b
            %An - ,  0  999999, 
            %ch_id -  , 0-64 , 
            %ph  -  , , 0-2 
            %ccbm -   (? ?  ). , 0-64 
            %uu - , 1-32 , 
            %a -  
            %b -  
            % y=a*x+b, -  .dat, y -  
            %skew -   . 1-32 
            %min, max  -     (-32767...+32767     -99999...+99999)
            %K=primary/secondary=I./I.,   
            
            %{An, ch_id, ph, ccbm, uu, a, b, skew, min, max, primary, secondary, PS}
            %PS- Primary, S - Secondary -        
            %             analog_data={
            %                 {[4 5 6],       {1, 'Ia', '','', 'kA', 1, 0,0,-32768,32767, 1,1 'P'}, 1};
            %                 {[7 8 9],       {2, 'Ib', '','', 'kA', 1, 0,0,-32768,32767, 1,1 'P'}, 1};
            %                 {[10 11 12], {3, 'Ic', '','', 'kA', 1, 0,0,-32768,32767, 1,1 'P'}, 1};
            %                 };
            %   : 1  , 0 - 
            
            % 
            %Dn, ch_id, ph, ccbm, y
            %Dn - , 1-6 , 
            %ch_id -  , 0-64 , 
            %ph  -  , , 0-2 
            %ccbm -   (? ?  ). , 0-64 
            %y -       ( 0,  1)
            %         digital_data={
            %             {[1;1;0],       {1, '', '','', 0}, 0};
            %             {[0;1;0],       {2, '', '','', 0}, 0};
            %             };
            %data=[analog_data; digital_data]
            %   0
            %}
            
            analog_data={};
            digital_data={};
            alldata=[];
            N=length(times);
            Ana_Ch=0;
            Dig_Ch=0;
            for i=1:length(data)
                if length(data{i}{1})~=N
                    error('  .  ')
                end
                if data{i}{3}==0
                    Dig_Ch=Dig_Ch+1;
                    digital_data{end+1}=data{i};
                else
                    analog_data{end+1}=data{i};
                    Ana_Ch=Ana_Ch+1;
                end
            end
            
            for i=1:length(analog_data)
                signal=analog_data{i}{1};
                max_val=analog_data{i}{2}{10};
                a=max(abs(signal))/max_val;
                analog_data{i}{2}{6}=a;
                alldata=[alldata COMTRADE.MakeColumnOrder(analog_data{i}{1})/a];
            end
            for i=1:length(digital_data)
                alldata=[alldata COMTRADE.MakeColumnOrder(digital_data{i}{1})];
            end
            
            numbers=(1:N)';
            %timestamps = (0:1:N-1)'*1/Info.samp_freq*1e+6; %,  
            timestamps=COMTRADE.MakeColumnOrder(times);
            alldata=[numbers round(timestamps*1e+6) alldata];
            
            dlmwrite(PathAndDatName, int32(alldata), 'newline', 'pc', 'precision', '%d');
            %       PathAndDatName,  
            %-  data (   int32 -  32, 
            %       ('newline'),   - CR/LF ('pc')
            %  ('precision')    '%d' (  (+  -)  )
            
            %%   cfg 
            PathAndCfgName=[Path FileName '.cfg'];
            fid = fopen(PathAndCfgName,'wt'); %      ,    
            fprintf(fid, '%s\n', [Info.station_name ',' Info.rec_dev_id ',1999']); %       , 1,1999, %! 
            fprintf(fid, '%s\n', [num2str(Ana_Ch + Dig_Ch),',',num2str(Ana_Ch),'A,',num2str(Dig_Ch),'D']);%  __, __, D__ %! 
            for i=1:length(analog_data)
                description=COMTRADE.CreateDescription(analog_data{i}{2});
                fprintf(fid, '%s\n', description); % . ! % 1
            end
            for i=1:length(digital_data)
                description=COMTRADE.CreateDescription(digital_data{i}{2});
                fprintf(fid, '%s\n', description); % . ! % 1
            end
            
            nrates=length(Info.sys_freq);%  
            fprintf(fid, '%s\n', num2str(Info.sys_freq),num2str(nrates)); % , %! 
            fprintf(fid, '%s\n', [num2str(Info.sample_freq),',',num2str(N)]); % , ___ %! 
            dt = clock;%    [, , , , , ]
            fprintf(fid, '%s\n', [num2str(dt(3),'%02.0f'),'/',num2str(dt(2)','%02.0f'),'/',num2str(dt(1),'%4.0f'),',',num2str(dt(4),'%02.0f'),...
                ':',num2str(dt(5),'%02.0f'),':',num2str(dt(6),'%08.6f')]); %//, :: ! 
            fprintf(fid, '%s\n', [num2str(dt(3),'%02.0f'),'/',num2str(dt(2)','%02.0f'),'/',num2str(dt(1),'%4.0f'),',',num2str(dt(4),'%02.0f'),...
                ':',num2str(dt(5),'%02.0f'),':',num2str(dt(6),'%08.6f')]); %//, :: ! 
            
            fprintf(fid, '%s\n','ASCII', num2str(Info.timemult)); %ASCII  %! % 1
            fclose(fid); % 
        end
        function description=CreateDescription(cell_data)
            description='';
            for i=1:length(cell_data)
                description=[description ',' num2str(cell_data{i})];
            end
            description(1)=[];%  
        end
        function result=MakeColumnOrder(data)
            [m,n]=size(data);
            if m==1
                result=data';
            else
                result=data;
            end
        end
        
        %%  
        function out=ReadComtrade(oscReadSettings)
            %% Comtrade Reader function
            %{
            % This file is designed to decode the data stored in COMTRADE format,
            % as defined in IEEE C37.111-1999. This involves the opening of two files,
            % one containing the configuration (.cfg) information and the other
            % the data (.dat).
            %
            % COMTRADE provides a common format for the data files and exchange medium
            % needed for the interchange of various types of fault, test, or simulation
            % data.
            % Use the uigetfile function to load the .cfg file, which is then used to
            % load the associated .dat file
            % First, get the .cfg file information
            %}
            if strcmp(oscReadSettings.encoding,'OEM866')
                OEM866=true;
            else
                OEM866=false;
            end
            Path=COMTRADE.AddSlash(oscReadSettings.path);
            FileName=COMTRADE.RemoveExtension(oscReadSettings.filename);%   
            
            PathAndCfgName =[Path  FileName '.cfg'];
            PathAndDatName =[Path FileName '.dat'];
            
            % Now open the .cfg and .dat files
            cfg_id = fopen(PathAndCfgName);
            dat_id = fopen(PathAndDatName);
            
            % Scan the text into local cells cfg and dat.
            cfg = textscan(cfg_id, '%s', 'delimiter', '\n');
            dat = textscan(dat_id, '%s', 'delimiter', '\n');
            
            % close all open files, as we're done with them now.
            fclose('all');
            
            %% start to decode the data
            
            cfg_len = length(cfg{1,1});
            cfg_string = cell(size(cfg));
            
            for i = 1:cfg_len
                if OEM866
                    temp_string = COMTRADE.toOEM866(char(cfg{1,1}{i}));
                else
                    temp_string = char(cfg{1,1}{i});
                end
                cfg_string(i) = textscan(temp_string, '%s', 'Delimiter', ',')';
            end
            % Comtrade File Identifier
            Title = char(cfg_string{1,1}(1));
            % Comtrade Version
            if length(cfg_string{1,1}) < 3
                Version = '1999';
            else
                Version = char(cfg_string{1,1}(3));
            end
            
            % Channel information: total, analogues and digitals
            No_Ch = strread(char(cfg_string{1,2}(1))); %- 
            Ana_Ch = strread(char(cfg_string{1,2}(2)));%-  
            Dig_Ch = strread(char(cfg_string{1,2}(3)));%-  
            
            dat_len = strread(char(cfg_string{1,5+No_Ch}(2)));% Data length, i.e. no of samples
            frequency = strread(char(cfg_string{1,3+No_Ch}(1)));% Nominal frequency
            timemult=strread(char(cfg_string{1,4+No_Ch}(1)));% Nominal frequency
            
            samp_rate = strread(char(cfg_string{1,5+No_Ch}(1)));% Sampling rate
            
            % Record started
            start_date = char(cfg_string{1,6+No_Ch}(1));
            start_time = char(cfg_string{1,6+No_Ch}(2));
            
            % Record ended
            end_date = char(cfg_string{1,7+No_Ch}(1));
            end_time = char(cfg_string{1,7+No_Ch}(2));
            
            %%  dat 
            %dat_string = cell(size(dat));
            data = zeros(dat_len, No_Ch+2);
            % Now extract the data   
            for i = 1:dat_len
                dat_string = textscan(char(dat{1,:}(i)), '%n', 'Delimiter', ',');
                data(i,:) = dat_string{1}'; % ,  
            end
            % extract the timestamps, scaled to seconds from microseconds
            t = (data(:,2)) * 1e-6*timemult;
            out.times=t;%     
            % All channels are extracted here, but the analogues still need scaling
            
            %%   
            di_cfg=2;%   ,  ,   .  2   cfg    
            for i = 1 : Ana_Ch %   ,      ,    
                j = i + di_cfg;
                %{
                % % Limit the range of the result
                % min_level = strread(char(cfg_string{1,j}(9)));
                % max_level = strread(char(cfg_string{1,j}(10)));
                % % Lower limit check ?
                % if data(:,j) <= min_level
                %     data(:,j) = min_level;
                % end
                % % Upper limit check ?
                % if data(:,j) >= max_level
                %     data(:,j) = max_level;
                % end
                %}
                % If the Primary and Secondary scaling information is  present, apply that too
                scale=1;
                if length(cfg_string{1,j}) == 13
                    primary = str2double(char(cfg_string{1,j}(11)));
                    secondary = str2double(char(cfg_string{1,j}(12)));
                    used_factor = char(cfg_string{1,j}(13));
                    if strcmp(used_factor,'S')||strcmp(used_factor,'s')
                        scale=scale*primary/secondary;%????
                    end
                end
                units=char(cfg_string{1,j}(5));
                if ~isempty(units)
                    if strcmp(units(1),'k')
                        scale=scale*1e3;
                    elseif strcmp(units(1),'M')
                        scale=scale*1e6;
                    elseif strcmp(units(1),'m')
                        scale=scale*1e-3;
                    end
                end
                % The value is scaled by the equation [aX + b]
                a = str2double(char(cfg_string{1,j}(6)));%a
                b = str2double(char(cfg_string{1,j}(7)));%b
                skew= str2double(char(cfg_string{1,j}(8)));%
                
                out.ana_channels{i}.N=  int32(str2double(char(cfg_string{1,j}(1))));
                out.ana_channels{i}.ch_id= char(cfg_string{1,j}(2));
                out.ana_channels{i}.ph=char(cfg_string{1,j}(3));
                out.ana_channels{i}.ccbm= char(cfg_string{1,j}(4));
                out.ana_channels{i}.values = (data(:,j) * a  + b)*scale;
                out.ana_channels{i}.times=t+skew*1e-6;%        skew
            end
            
            %%   
            di_cfg=di_cfg+Ana_Ch;
            for i = 1 : Dig_Ch %   ,      ,    
                j = i + di_cfg;
                out.dig_channels{i}.N= int32(str2double(char(cfg_string{1,j}(1))));
                out.dig_channels{i}.ch_id=char(cfg_string{1,j}(2));
                if length(cfg_string{1,j})>=4
                    out.dig_channels{i}.ph= char(cfg_string{1,j}(3));
                    out.dig_channels{i}.ccbm= char(cfg_string{1,j}(4));
                else
                    out.dig_channels{i}.ph= '';
                    out.dig_channels{i}.ccbm= '';
                end
                out.dig_channels{i}.values = data(:,j) ;
                out.dig_channels{i}.times=t;
            end
            
            %% Write the remainaing config information to the workspace
            out.info.Title=Title;
            out.info.Version=Version;
            out.info.No_Ch=No_Ch;
            out.info.Ana_Ch=Ana_Ch;
            out.info.Dig_Ch=Dig_Ch;
            out.info.frequency=frequency;
            out.info.samp_rate=samp_rate;
            out.info.start_date=start_date;
            out.info.start_time=start_time;
            out.info.end_date=end_date;
            out.info.end_time=end_time;
        end
        function new_string=toOEM866(source_string)
%         bytes=unicode2native(source_string,'UTF-8');
%             new_bytes=[];
%             for i=1:length(bytes)
%                 if bytes(i)>=192&&bytes(i)<=239
%                     new_bytes(i)=bytes(i)-64;
%                 elseif bytes(i)>=240&&bytes(i)<=255
%                     new_bytes(i)=bytes(i)-16;
%                 elseif bytes(i)==168
%                     new_bytes(i)=240;
%                 elseif bytes(i)==184
%                     new_bytes(i)=241;
%                 else
%                     new_bytes(i)=bytes(i);
%                 end
%             end
%             new_string=native2unicode(new_bytes);
            % 
            ANSI='񦧨';
            OEM866='Ũ';
            new_string='';
            for i=1:length(source_string)
                symbol=source_string(i);
                new_symbol=symbol;
                for k=1:length(ANSI)
                    if symbol==ANSI(k)
                        new_symbol=OEM866(k);
                        break
                    end
                end
%                 byte=unicode2native(source_string(i),'UTF-8');
%                 if byte==152
%                     new_symbol='';
%                 end
                new_string=[new_string new_symbol];
            end
        end
        %% 
        function filename=RemoveExtension(filename)
            dot_index=0;
            for i=1:length(filename)
                if filename(i)=='.'
                    dot_index=i;
                end
            end
            if dot_index~=0
                filename=filename(1:dot_index-1);
            end
        end
        function path=AddSlash(path)
            if path(end)~='\'
                path(end+1)='\';
            end
        end
        
    end
    
end
    