classdef DataLine<handle
    %DATALINE Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        fun %        
        arg %
        
        interp_method='spline'
        
        name %  (  )
    end
       
    properties (Dependent=true)
        IsValid
        Num
    end
    
    
    methods
        %% Get, Set 
        function value=get.IsValid(this)
            value=false;
            if ~isempty(this.fun)&&~isempty(this.arg)&&length(this.arg)==length(this.fun)
                value=true;
            end
        end
        function value=get.Num(this)
            if this.IsValid
                value=length(this.fun);
            end
        end
        
        %% 
        function copy_object=Clone(this)
            copy_object=DataLine(this.arg,this.fun);
        end
        
        function this=DataLine(x,y)
            if nargin==2&&isnumeric(x)&&isnumeric(y)
                if size(x,1)>1
                    x=x.';
                end
                if size(y,1)>1
                    y=y.';
                end
                
                this.arg=x;
                this.fun=y;
            end
        end
        
        %%  
        function y_arr=FunValue(this, x) % y( x)
            y_arr=[];
            if this.IsValid
                y_arr=interp1(this.arg,this.fun, x, this.interp_method);
            end
        end
        
        function value=Max_arg(this)
            value=max(this.arg);
        end        
        function value=Min_arg(this)
            value=min(this.arg);
        end
        
        function value=Max_fun(this)
            value=max(this.fun);
        end
        function value=Min_fun(this)
            value=min(this.fun);
        end
       
        function a_clone=minus(a, b)
            [a_clone, b_clone]=DataLine.VerifyArithmetic(a,b);
            a_clone.fun=a_clone.fun-b_clone.FunValue(a.arg);
        end
        function a_clone=plus(a, b)
            [a_clone, b_clone]=DataLine.VerifyArithmetic(a,b);
            a_clone.fun=a_clone.fun+b_clone.FunValue(a.arg);
        end
        function a_clone=mtimes(a,b)
            [a_clone, b_clone]=DataLine.VerifyArithmetic(a,b);
            a_clone.fun=a_clone.fun.*b_clone.FunValue(a.arg);
        end
        function a_clone=mrdivide(a,b)
            [a_clone, b_clone]=DataLine.VerifyArithmetic(a,b);
            a_clone.fun=a_clone.fun./b_clone.FunValue(a.arg);
        end
        
        function ChangeArgLimits(this, new_min, new_max)
            if new_min>=new_max
                error('  ')
            end
            
            max_changed=false;
            min_changed=false;
            i=1;
            while true
                if i>length(this.arg)
                    break
                end
                if this.arg(i)<new_min
                    this.arg(i)=[];
                    this.fun(i)=[];
                    min_changed=true;
                else
                    break
                end
            end

            i=length(this.arg);
            while true
                if i<1
                    break
                end
                if this.arg(i)>new_max
                    this.arg(i)=[];
                    this.fun(i)=[];
                    i=i-1;
                    max_changed=true;
                else
                    break
                end
            end
            
            new_arg=this.arg;
            if min_changed
                new_arg=[new_min new_arg];
            end
            if max_changed
                new_arg=[new_arg new_max];
            end
            
            this.fun=this.FunValue(new_arg);
            this.arg=new_arg;
        end
    end
    
    methods (Static)
        function [a_clone, b_clone]=VerifyArithmetic(a,b)
            min_x_a=a.Min_arg;
            min_x_b=b.Min_arg;
            max_x_a=a.Max_arg;
            max_x_b=b.Max_arg;
            
            new_min=max([min_x_a min_x_b]);
            new_max=min([max_x_a max_x_b]);   
            
            a_clone=a.Clone();
            b_clone=b.Clone();
            
            a_clone.ChangeArgLimits(new_min, new_max);
            b_clone.ChangeArgLimits(new_min, new_max);
        end
    end
    
end

