classdef Frequency<handle
    
    methods (Static)

        function y = DFT(time, value, f)
            w=2*pi*f;
            N=length(time);
            y=2i/N*sum(value.*exp(-1i*w*time));
        end
%{
%         function [F, time_out]=FrequencyCompariser(Y, N, f)
%             if ~isa(Y, 'DataLine')
%                 error('  ')
%             end
%             dt=1/f/N; %  
% %             t2=t1+(N-1)*dt;
%             
%             tmin=Y.Min_arg();
%             tmax=Y.Max_arg();
% %             if t1<tmax||t2>tmin
% %                 error('   ')
% %             end
%             
%             t=tmin:dt:tmax;
%             y=Y.FunValue(t);
%             
%             num=length(t)-N;
%             F=zeros(1,num);
%             for i=1:num
%                 time1=t(i:N+i-1);
%                 value1=y(i:N+i-1);
%                 
%                 time2=t(i+1:N+i);
%                 value2=y(i+1:N+i);
%                 
%                 Xfft1=Frequency.DFT(time1,value1,f);
%                 Xfft2=Frequency.DFT(time2,value2,f);
% %                 dt=time(N+i)-time(N+i-1);
%                 F(i)=f+1/(2*pi)*( angle(Xfft2/Xfft1) )/dt;
%             end
%             
%             time_out=t(N+1:end);
%         end
 %}       
        function d=DispersionEstimator(Y, tmin, tmax, N, f)
            dt=1/f/N; %  

            t=tmin:dt:tmax;
            y=Y.FunValue(t);
            
            num=length(t)-N;
            F=zeros(1,num);
            for i=1:num
                time1=t(i:N+i-1);
                value1=y(i:N+i-1);
                
                time2=t(i+1:N+i);
                value2=y(i+1:N+i);
                
                Xfft1=Frequency.DFT(time1,value1,f);
                Xfft2=Frequency.DFT(time2,value2,f);

                F(i)=f+1/(2*pi)*( angle(Xfft2/Xfft1) )/dt;
            end
            d=var(F);
        end
        
        function f1=FrequencyNewtonEstimator(Y, tmin, tmax, N, f1, epsilon)
            if ~isa(Y, 'DataLine')
                error('  ')
            end
%             f1=50;% 
%             epsilon=1e-6;
%             num=4;
            df=10^-3*f1;
            k=1;
            while true
                if df==0
                    break
                end
                D1=Frequency.DispersionEstimator(Y, tmin, tmax, N, f1);
                D2=Frequency.DispersionEstimator(Y, tmin, tmax, N, f1+df);
                derD=(D2-D1)/df;
                f2=f1-D1/derD;
                df=f2-f1;
                f1=f2;
                k=k+1;
                if abs(df)<=epsilon||k==10
                    break
                end
            end           
            
        end
        
        function [f, t]=FrequencyDetector(Y, N, f1, epsilon)
            tmin=Y.Min_arg();
            tmax=Y.Max_arg();
            
            dT=1/f1*2;
            if tmin+dT>=tmax
                error('   ')
            end
            t1=tmin:dT:(tmax-dT);
            for i=1:length(t1)
                f(i)=Frequency.FrequencyNewtonEstimator(Y, t1(i), t1(i)+dT, N, f1, epsilon);
                t(i)=t1(i)+dT;
            end
        end
        
    end

end